;The following should build up a 40x25 ch64 screen with char height 8, ALTIND0 and ALTIND1 is set so there are 4 colour pairs what you can use:

                MACRO exos n
                  RST 30H
                  DB  n
                ENDM

	device zxspectrum128
        ORG $F0
begin
	;16 bytes EXOS file header (not needed in Enterprise assemblers)
	DB 0,5		;type 5 = machine code application program
	DW VEGE-100H	;16 bit lenght
	DB 0,0,0,0,0,0,0,0,0,0,0,0 ;not used bytes

lptaddr equ     0f000h
scraddr equ     0c000h
fontadd equ     0c400h
scrwdth equ     28h             ;screen width 40
sheight equ     25              ;screen heihgt in char rows

	ld sp,$100
        call    vid		;alloc video segment for screen
        out     (0b3h),a
        ld      (vidpag1),a
        call    memaddr

        ld      (line+4),hl     ;address of screen
        push    hl
        ld	a,h
        add     a,04h
        ld	h,l
        rla
        rl      h
        rla
        rl      h
        ld      l,a
        ld      (line+6),hl	;address of character memory, screen+400h

        ld	    hl,line
        ld	    de,lptaddr
        ld	    bc,0010h
        ldir
        ld	    hl,lptaddr
        ld	    bc,(sheight-1)*10h;0180h
        ldir
        ld	    hl,sync
        ld	    bc,0050h
        ldir

        call    getchad         ;calculate Nick address of character rows

        pop     af
        add     30h             ;LPT address = address+3000H (Nick address)
        rrca
        rrca
        rrca
        rrca
        and     0fh
        or      0c0h
        ld      c,a
        xor     a
        out     (82h),a
        ld      a,c
        out     (83h),a

;        ld	    hl,line
;        ld	    de,lptaddr
;        ld	    bc,0010h
;        ldir
;        ld	    hl,lptaddr
;        ld	    bc,0180h
;        ldir
;        ld	    hl,sync
;        ld	    bc,0050h
;        ldir





;copy chars to
;Yes, if you got FC segment, we put char data (fonts) into 400h on FC segment, so the Nick address is 10h
;If you want to work with it, char data address is c400h, because we paged FC segment to page3.
;Ex Nick address of EXOS character font is 1f2h, because it is on FF segment at 3900h, and it is CH128, so f900h / 128= 1f2h

;Now the LPT wants to search at video page at 0400h which is paged into page3 so your working address is c400h for fonts,
;c000h for character map, and f000h for LPT.

font_a: ld de,$C400;;FONT_CPU_ADDRESS;$c000
 ld hl,font_data
 ld c,64
pf1:
 push de
 ld b,8
pf2: ld a,(hl)
 ld (de),a
 inc hl
 ld a,e:add a,128/2:ld e,a
 ld a,d:adc a,0:ld d,a
 djnz pf2
 pop de
 inc de
 dec c:jr nz, pf1

;scra: ld hl,$C000
;slp: ld a,l
;; and 63
; ld (hl),a
; inc l:jr nz,slp
; jr $
;----------------------------------------------------------------------
 ld bc,#7f00

 ld h,c,l,c,d,c,e,c
 ;--pop hl,de
; ld hl,0,de,0
genlp:
  add hl,de
  ld a,h
; Reflect the value around for a sine wave
  ld (bc),a
  push bc
  ;ld a,#7f:sub c:ld c,a
  ld a,b:sub c:ld c,a

  ;ld a,64*2:sub h
  ld a,b:sub h

  ld (bc),a
  pop bc
;next iteration
 ld a,e
 add a,#8;10;8
 ld e,a
 jr nc,next
 inc d
next:
 inc c
 bit 6,c:jr z,genlp
 ld d,b,e,#80,c,b;#7f
neglp: ld a,(bc)
 sra a
  ld (bc),a
  ld (de),a
 inc e:dec c:jr nz,neglp

  ld h,b


  pop de,bc
;-----------intro
dointro:
 push de
 push bc
 exx
 ld hl,#C000
 exx
 ld h,#7f
;var2:ld bc,0
 ld ixl,25
ylp:
 push de;var1:ld de,0
 
 ld a,40
xlp:
 exa
 ld a,d:add a,8:ld d,a
 ld a,e:add a,0-6:ld e,a

 ld l,e:ld a,(hl)
 ld l,d:add a,(hl)
 ld l,c:add a,(hl)
 ld l,b:add a,(hl)


 exx
 ld (hl),a:inc hl
 exx
;xlp
 exa
 dec a
 jp nz, xlp
 ld a,b:add a,5+1:ld b,a
 ld a,c:add a,7:ld c,a

 pop de
 ;exx:bit 2,h:exx
 dec ixl
 jp nz,ylp
 
 
 pop bc:inc b,c,c,c
 pop de:inc e,d,d
 jp dointro

;----------------------------------------------------------------------
vidpag1: db 0

getchad ld      de,(line+4)
        ld      hl,lptaddr+04h
        ld      a,sheight
gtchad1 ld      (hl),e
        inc     l
        ld      (hl),d
        ld      bc,000fh
        add     hl,bc
        ex      de,hl
        ld      c,scrwdth
        add     hl,bc
        ex      de,hl
        dec     a
        jr      nz,gtchad1
        ret

;----------------------------------------------------
hiba:           DI
                LD SP,100H	;set User Stack
                LD A,255	;system segment
                OUT (0B2H),A	;to page 2.
                LD HL,hiba
                LD (0BFF8H),HL	;set Warm ReStart address
                LD HL,(0BFF4H)	;EXOS LPT address
                SET 6,H		;convert to video address
                LD B,4		;rotate with 4 bits
ELPT:           SRL H
                RR L
                DJNZ ELPT
                LD A,L		;low byte
                OUT (82H),A	;send to Nick
                LD A,H		;high 4 bits
                OR 0C0H		;enable Nick running
				;switch to the new LPT
				;at the end of current frame
                OUT (83H),A	;send to Nick
                LD A,0F5H	;restore original
                LD HL,1837H	;EXOS IRQ ruotine
                LD (38H),A	;starting
                LD (39H),HL	;
				;If we make a own IRQ
				;routine with placing
				;JP instruction to 38h
                
                LD C,40H	;reset code=40 Deallocate all User RAM
                exos 0		;EXOS reset
                LD A,1		;Rom 1.
                OUT (0B3H),A	;to page 3.
                LD A,6		;6. function= Enterprise logo screen
                JP 0C00DH	;exit to ROM
;----------------------------------------------------
vid     ld      hl,stack
        ld      (hl),0
ker     exos    24
        jr      z,namivan
        cp      7fh
        jp      nz,hiba
namivan ex      af,af'
        ld      a,c
        cp      0fch
        jr      nc,nemker
        inc     hl
        ld      (hl),c
        jr      ker
nemker  ex      af,af'
        push    bc
        push    af
vissza  ld      c,(hl)
        exos    25
        dec     hl
        jr      z,vissza
        pop     af
        pop     bc

;        cp      0f5h
;        jp      z,hiba			;7f if a shared segment, f5 if no segment

        cp      7fh
        ld      a,c				;a contains the page
;        jr      z,userbnd
        jp      z,hiba
        ret

memaddr ld      de,0000h
        rra
        rr      d
        rra
        rr      d
        ex      de,hl
        ret

;char height is 8, ch64 mode, left margin 11, right margin 51 and ALTIND0, ALTIND1 set which make possible to use 4*2 colours in character mode by playing bit 6,7 of character code.
line    db      0f8h,00ah,1fh-(scrwdth/2),1fh+(scrwdth/2)+0c0h,00h,00h,00h,00h	;25*8 = 200

;        db      001h,002h,003h,004h,05h,06h,07h,08h
        db      002h,012h; background, fore for 0-63 chars
        db 		042h,0BAh ;128-191
        db		042h,03ah;64-127
        db		002h,05Ah;192-255
;        db      006h,002h,022h,042h,062h,082h,0A2h,0C2h

sync    db      0ceh,09eh,03fh,020h,00h,00h,00h,00h	;sync 
        db      00,00,00,00,00,00,00,00          	;52
        db      0fdh,0,3fh,0,0,0,0,0
        db      00,00,00,00,00,00,00,00          	;3
        db      0fch,0,6,3fh,0,0,0,0
        db      00,00,00,00,00,00,00,00          	;4
        db      0ffh,10h,3fh,20h,0,0,0,0
        db      00,00,00,00,00,00,00,00          	;1
        db      0ceh,3,3fh,6,0,0,0,0,0
        db      00,00,00,00,00,00,00,00          	;52

font_data:
  incbin "bn_tile.bin"

endpr	equ     $
VEGE:
stack:
end

	display /d,end-begin
	savebin "plasma.com",begin,end-begin
